package avatartranslator.tosysmlv2;
import java_cup.runtime.ComplexSymbolFactory.Location;

public class AvatarFromSysMLError {
    public static final byte LOWWARNING = 0;
    public static final byte HIGHWARNING = 1;
     public static final byte LOWERROR = 2;
    public static final byte HIGHERROR = 3;
    public static final byte BUGERROR = 4;
   private Location location;
    private Location reference;
    private String message;
    private byte level;
    public AvatarFromSysMLError(Byte lv, Location loc, String msg, Location ref){
        location = loc;
        reference = ref;
        message = msg;
        level = lv;
    }
    public AvatarFromSysMLError(Byte lv, Location loc, String msg){
        location = loc;
        reference = null;
        message = msg;
        level = lv;
    }
    public AvatarFromSysMLError(Byte lv, String msg){
        location = null;
        reference = null;
        message = msg;
        level = lv;
    }
    @Override
    public String toString() {
        StringBuffer res = new StringBuffer();
        if (level > BUGERROR || level < LOWWARNING)
            res.append("PROBLEM ");
        else if (level == LOWWARNING)
            res.append("Warning ");
        else if (level == HIGHWARNING)
            res.append("WARNING ");
        else if (level == LOWERROR)
            res.append("Error ");
        else if (level == HIGHERROR)
            res.append("ERROR ");
        else
            res.append("BUG ");
        if (location != null)
            res.append("(l" + location.getLine() + ",c" + location.getColumn() + ")");
        res.append(": " + message);
        if (reference != null)
            res.append(" (c.f. l" + reference.getLine() + ",c" + reference.getColumn() + ")");
        res.append("\n");
        return res.toString();
    }

}
